<%
'**********************************************************************************
' VP-ASP 6.50
' Author: Howard Kadetz
'  Summary
'  Generates a drop down list of countries. The fieldname is the current value of the 
'  country and will be set as selected if it exists. 
'  common countries can be specified first in the list
'  followed by all countries
' xdisplaystates=US,UK,AU         list of countries whose states are to display
' Modification:
' Nov 7, 2006      Redeveloped using shopcountries table
'*********************************************************************************
Sub ShopCountries(formname, fieldname,other)
dim sql, rs, countryname, countryabbrev, selected
dim dbc, i, selecteddone, count
response.write "<select class=""txtfielddropdown"" name=""" & formname & """ size=""1"">" & vbcrlf

countryabbrev=""
countryname=getlang("langcommonselect")           ' prompt in drop down list
If fieldname="" then                            ' make prompt the default
         selected=" selected=""selected"""
         selecteddone=true
else
   selecteddone=false
end if            
response.write "<option value=""" & countryabbrev  & """ " &  selected & ">" &  countryname & "</option>"    & vbcrlf

'VP-ASP 6.50 - if other = yes then add "other" as option
if UCASE(other) = "YES" then
	if lcase(fieldname) = "other" then 
		selected = " selected=""selected"""
	end if
	response.write "<option value=""other"" " &  selected & ">Other</option>"    & vbcrlf
	selected = ""
end if

selected=""
count=0
shopopendatabase dbc                     ' open database
sql="Select * from shopcountries where (countryhide=0 OR countryhide IS NULL) and countrydisplayorder is not null"
sql=sql & " order by countrydisplayorder"
set rs=dbc.execute(sql)
do while not rs.eof
    countryname=rs("countryname")            ' full name
    countryabbrev=rs("country")        ' abrreviation
    selected=""   
    if selecteddone=false then          ' have we seletec something
	 'VP-ASP 6.50.1 - added UCASE to both fields below
      if ucase(fieldname)=ucase(countryabbrev) then
        selected=" selected=""selected"""
        selecteddone=true
      end if
    end if  
    response.write "<option value=""" & countryabbrev  & """" &  selected & ">" &  countryname & "</option>"    & vbcrlf
    selected=""
    count=count+1
    rs.movenext                          ' next cuntry
loop
closerecordset rs
' if there were special countrys put a separator after them
if count>0 then
     countryabbrev=""
     countryname="------------"
     response.write "<option value=""" & countryabbrev  & """" &  selected & ">" &  countryname & "</option>"    & vbcrlf
end if     
'*********************************************************************************
' now that the special countries have been done, do all remaining countries
'*********************************************************************************
sql="Select * from shopcountries where (countryhide=0 OR countryhide IS NULL) "
sql=sql & " order by countryname"
set rs=dbc.execute(sql)
do while not rs.eof
    countryname=rs("countryname")            ' full name
    countryabbrev=rs("country")        ' abrreviation
    selected=""   
    if selecteddone=false then          ' have we seletec something
      if fieldname=countryabbrev then
        selected=" selected=""selected"""
        selecteddone=true
      end if
    end if  
    response.write "<option value=""" & countryabbrev  & """" &  selected & ">" &  countryname & "</option>"    & vbcrlf
    selected=""
    rs.movenext                          ' next state
loop
closerecordset rs
response.write "</select>"
shopclosedatabase dbc
end sub
%>      