<%
'**********************************************************************************
' VP-ASP 6.50
' Author: Howard Kadetz
' Summary
'  Generates a drop down list of states. The fieldname is the current value of the 
'  state and will be set as selected if it exists. Group states by country
' xdisplaystates=US,UK,AU         list of countries whose states are to display
' Modification:
' Nov 7, 2006      Redeveloped using shopstates table
'*********************************************************************************
Sub ShopStates (formname,fieldname)
dim sql, rs, statename, stateabbrev, selected
dim dbc, i, selecteddone
dim countries(10), displaycount, country
dim statelist                                  ' list of countries
statelist=getconfig("xdisplaystates")          ' find out what countries we want states for
response.write "<select class=""txtfielddropdown"" name=""" & formname & """ size=""1"">" & vbcrlf
stateabbrev=""
statename=getlang("langcommonselect")           ' prompt in drop down list
If fieldname="" then                            ' make prompt the default
         selected=" selected=""selected"""
         selecteddone=true
else
   selecteddone=false
end if            
response.write "<option value=""" & stateabbrev  & """ " &  selected & ">" &  statename & "</option>"    & vbcrlf

if lcase(getsess("State")) = "none" then
	selected=" selected=""selected"""
else
selected=""
end if
stateabbrev="None"
statename="None"
response.write "<option value=""" & stateabbrev  & """ " &  selected & ">" &  statename & "</option>"    & vbcrlf
shopopendatabase dbc                     ' open database
If statelist="" then statelist="US"      ' default to only US states
parserecord statelist,countries, displaycount,","
for i = 0 to displaycount-1                    ' go through each country
   country=countries(i)
   sql="Select * from shopstates where ((statehide=0) OR (statehide IS NULL)) "
   sql=sql & " and statecountry='" & country & "'"
   sql=sql & " order by statename"
   set rs=dbc.execute(sql)                  ' open recordset
   If i>0 then  
      shopstatedisplaycountry dbc, country
   end if   
   do while not rs.eof                   ' go through all vales 
    statename=rs("statename")            ' full name
    stateabbrev=rs("stateabbrev")        ' abrreviation
    selected=""   
    if selecteddone=false then          ' have we seletec something
	  'VP-ASP 6.50.1 - added UCASE to both fields below
      if ucase(fieldname)=ucase(stateabbrev) then
        selected=" selected"
        selecteddone=true
      end if
    end if  
    response.write "<option value=""" & stateabbrev  & """" &  selected & ">" &  statename & "</option>"    & vbcrlf
    selected=""
    rs.movenext                          ' next state
   loop
   closerecordset rs
next                                      ' go to next country
response.write "</select>"
shopclosedatabase dbc
end sub
'*********************************************************************************
' generate a html separator for each country
' in form 
' <option value>----- CANADA ----
'*******************************************************************************
sub Shopstatedisplaycountry (dbc, country)
dim countryname
dim crs, csql
csql="select * from shopcountries where country='" & country & "'"
set crs=dbc.execute(csql)
if not crs.eof  then
   countryname=crs("countryname")
else
  countryname=""
end if
closerecordset crs
response.write "<option value="""">----- " &  countryname & " ----- </option>"    & vbcrlf      
end sub
%>      